"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from codat_platform.models.shared import syncsetting as shared_syncsetting
from codat_platform.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class UpdateProfileSyncSettingsRequestBodyTypedDict(TypedDict):
    r"""Include a `syncSetting` object for each data type.
    `syncFromWindow`, `syncFromUTC` & `monthsToSync` only need to be included if you wish to set a value for them.
    """

    client_id: str
    r"""Unique identifier for your client in Codat."""
    settings: List[shared_syncsetting.SyncSettingTypedDict]
    overrides_defaults: NotRequired[bool]
    r"""Set to `True` if you want to override default [sync settings](https://docs.codat.io/knowledge-base/advanced-sync-settings)."""


class UpdateProfileSyncSettingsRequestBody(BaseModel):
    r"""Include a `syncSetting` object for each data type.
    `syncFromWindow`, `syncFromUTC` & `monthsToSync` only need to be included if you wish to set a value for them.
    """

    client_id: Annotated[str, pydantic.Field(alias="clientId")]
    r"""Unique identifier for your client in Codat."""

    settings: List[shared_syncsetting.SyncSetting]

    overrides_defaults: Annotated[
        Optional[bool], pydantic.Field(alias="overridesDefaults")
    ] = True
    r"""Set to `True` if you want to override default [sync settings](https://docs.codat.io/knowledge-base/advanced-sync-settings)."""
